//+------------------------------------------------------------------+
//|                                            TrendFletAnalysis.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"
#property show_inputs

extern int		ind_Points				= 100;
extern double	ind_Percent				= 0.0;
extern bool		ind_chHL					= true;
extern bool		ind_Texts				= false;
extern color	ind_color_ZZ			= DeepSkyBlue;
extern color	ind_color_txt			= Yellow; 
extern bool		ind_Show_C0				= false;

int start()
{
	string name;
	for ( int o = ObjectsTotal()-1; o >= 0; o -- )
	{
		name = ObjectName(o);
		if ( StringFind( name, "TFA_" ) == 0 ) ObjectDelete( name );
	}

	double z, h, l, pre_z, pre_h, pre_l; int pre_i = 0, trends_count = 0, flets_count = 0, trend_summ_len = 0, flet_summ_len = 0;
	for ( int i = Bars - 1; i >= 0; i -- )
	{
		z = iCustom( NULL, 0, "ZZmufxytxt", ind_Points, ind_Percent, ind_chHL, ind_Texts, ind_color_ZZ, ind_color_txt, ind_Show_C0, 0, i );
		if ( z < Point || z == EMPTY_VALUE ) continue;

		h = iCustom( NULL, 0, "ZZmufxytxt", ind_Points, ind_Percent, ind_chHL, ind_Texts, ind_color_ZZ, ind_color_txt, ind_Show_C0, 1, i );
		l = iCustom( NULL, 0, "ZZmufxytxt", ind_Points, ind_Percent, ind_chHL, ind_Texts, ind_color_ZZ, ind_color_txt, ind_Show_C0, 2, i );

		if ( pre_i > 0 )
		{
			ObjectCreate( "TFA_"+i, OBJ_TREND, 0, Time[pre_i], 0.0, Time[i], 0.0 );
			ObjectSet	( "TFA_"+i, OBJPROP_RAY, false );
			ObjectSet	( "TFA_"+i, OBJPROP_WIDTH, 2 );

			if ( z > pre_z )
			{
				ObjectSet( "TFA_"+i, OBJPROP_PRICE1, pre_h );
				ObjectSet( "TFA_"+i, OBJPROP_PRICE2, l );
				if ( l > pre_h )
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, Lime );
					trends_count ++;
					trend_summ_len += pre_i-i;
				}
				else
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, White );
					flets_count ++;
					flet_summ_len += pre_i-i;
				}
			}
			else
			{
				ObjectSet( "TFA_"+i, OBJPROP_PRICE1, pre_l );
				ObjectSet( "TFA_"+i, OBJPROP_PRICE2, h );
				if ( h < pre_l )
				{
					ObjectSet	( "TFA_"+i, OBJPROP_COLOR, Red );
					trends_count ++;
					trend_summ_len += pre_i-i;
				}
				else
				{
					ObjectSet( "TFA_"+i, OBJPROP_COLOR, White );
					flets_count ++;
					flet_summ_len += pre_i-i;
				}
			}
		}

		pre_i = i;
		pre_z = z;
		pre_h = h;
		pre_l = l;
	}

	double trend_perc = trend_summ_len/(Bars/100.0);
	double flet_perc  = flet_summ_len /(Bars/100.0);

	Comment( WindowExpertName(), ":\n",
				"T: ", trends_count, " (", DoubleToStr( trend_perc, 1 ), "%, ", trend_summ_len, " bars)", "\n",
				"F: ", flets_count , " (", DoubleToStr( flet_perc , 1 ), "%, ", flet_summ_len, " bars)", "\n",
				"\n" );
	return(0);
}

